//  ANLEGEN DER FUNKTION initialization

void initialization() {

  Serial.begin(9600);
  pinMode(directionPin1, OUTPUT);
  pinMode(stepPin1, OUTPUT);
  pinMode(magnetPin, INPUT);

  /* Es wird überprüft, ob sich der Magnet zu Beginn der Messung in Reichweite des Sensors befindet.
     Falls ja, wird der Teller um 45° gedereht, um außer Reichweie des Magneten zu kommen. So kann
     sichergestellt werden, dass der Magnet ein mal komplett überfahren wird.
  */

  int magnetStatus = digitalRead(magnetPin);

  if (magnetStatus == 1) {
    digitalWrite(directionPin1, HIGH);   // Motorrotation im Uhrzeigersinn
    // drehe Motor 45°

    for (int i = 0; i < stepsPerRound * gearRatio / 8; i++) {
      digitalWrite(stepPin1, HIGH);
      delayMicroseconds(stepperSpeed);
      digitalWrite(stepPin1, LOW);
      delayMicroseconds(stepperSpeed);
    }

    Serial.println("Der Magnet befand sich zum Start in Reichweite.");          // Nur für den Entwicklungsmodus
    Serial.println("Der Teller wird um 45 Grad gedereht.");                     // Nur für den Entwicklungsmodus
    Serial.println("-----------------------------------");                      // Nur für den Entwicklungsmodus
    delay(2000);                                                                // Nur für den Entwicklungsmodus

  }

  Serial.println("Initialisierung läuft.");                                     // Nur für den Entwicklungsmodus
  Serial.println("-----------------------------------");                        // Nur für den Entwicklungsmodus

  // Für die eigentliche Initialisierung:
  // Drehe Motor 360°(Dauer: 5,7 Sekunden)
  // Motorrotation im Uhrzeigersinn

  digitalWrite(directionPin1, HIGH);

  for (int i = 0; i < stepsPerRound; i++) {

    // Mit der offset Funktion wird vor jedem Motorschritt der aktuelle Nullpunkt ermittelt

    offsetCount = i;
    offset();

    // Dann wird der Motor einen Schritt weitergedreht

    digitalWrite(stepPin1, HIGH);
    delayMicroseconds(stepperSpeed);
    digitalWrite(stepPin1, LOW);
    delayMicroseconds(stepperSpeed);

  }

  Serial.println("Der Magnet wurde überfahren.");                               // Nur für den Entwicklungsmodus
  Serial.print("Der aktuelle Step Counter ist ");                               // Nur für den Entwicklungsmodus
  Serial.print(stepCounter);                                                    // Nur für den Entwicklungsmodus
  Serial.println(".");                                                          // Nur für den Entwicklungsmodus
  Serial.println("-----------------------------------");                        // Nur für den Entwicklungsmodus
  Serial.println("Initialisierung ist abgeschlossen.");                         // Nur für den Entwicklungsmodus
  Serial.println("-----------------------------------");                        // Nur für den Entwicklungsmodus

}
