//  ANLEGEN DER FUNKTION jawStatus
/*  Diese Funktion erkennt, welche Zähne des Krokodils aktuell gedrückt sind und summiert sie auf.
    Der Status der Zähne wird in einem Array "teethStatus" der Länge 10 abgespeichert.
    Dabei entspricht der Wert 1 einem gedrückten Zahn und der Wert 0 einem nicht gedrückten Zahn.
    Die Summe der gedrückten Zähne wird in einer Variablen "teethSum" abgespeichert.
    Außerdem wird erkannt, ob das Krokodilmaul aktuell geschlossen oder geöffnet ist.
    Der Öffnungsstatus wird in der Variablen "mouthStatus" gespeichert.
    Dabei entspricht der Wert 1 einem geschlossenen Maul und der Wert 0 geöffneten Maul.
    Die Daten können über den seriellen Monitor bei Bedarf angezeigt werden.
*/

void jawStatus () {

  // Es sollen 10 Werte für die Zähne aufgezeichnet werden, dazu wurde in der Main ein Array "teethStatus" angelegt

  /* Die Pins tooth1 bis tooth10, sowie mouth werden als Input-Pins festgelegt
     Durch die Pullup-Funktion wird der jeweilige Pin auf "HIGH" gesetzt,
     wenn der Stromfluss unterbrochen ist.
  */

  pinMode(mouth, INPUT_PULLUP);
  pinMode(tooth1, INPUT_PULLUP);
  pinMode(tooth2, INPUT_PULLUP);
  pinMode(tooth3, INPUT_PULLUP);
  pinMode(tooth4, INPUT_PULLUP);
  pinMode(tooth5, INPUT_PULLUP);
//  pinMode(tooth6, INPUT_PULLUP);
//  pinMode(tooth7, INPUT_PULLUP);
//  pinMode(tooth8, INPUT_PULLUP);
//  pinMode(tooth9, INPUT_PULLUP);
//  pinMode(tooth10, INPUT_PULLUP);

  /*  Erkennen und Abspeichern der Zahnzustände:
      Mit Hilfe der Zählervariable i sollen die Zeileneinträge des Arrays gezählt werden
      Da der erste belegte Pin tooth1 ist, ist auch i zu Beginn gleich tooth1
  */

  int i = tooth1;

  /*  Es werden nacheinander alle 10 Pins ausgelesen und der jeweilige Status im Array gespeichert
      Dabei entspricht HIGH dem Wert 1 und LOW dem Wert 0
  */

  for (i = tooth1; i < korkoTeeth + tooth1; i++) {
    int tooth = digitalRead(i);
    if (tooth == HIGH) {
      tooth = 1;
    }
    if (tooth == LOW) {
      tooth = 0;
    }
    teethStatus[i - tooth1] = tooth;
  }

  /* Erkennen und Abspeichern des Krokodilmaulzustands:
     Es wird Pin 2 ausgelesen und der Status gespeichert
     Dabei entspricht HIGH dem Wert 1 und LOW dem Wert 0
  */

  mouthStatus = digitalRead(mouth);
  if (mouthStatus == HIGH) {
    mouthStatus = 1;
  }
  if (mouthStatus == LOW) {
    mouthStatus = 0;
  }

  // In der Variable "teethSum" werden die gedrückten Zähne aufsummiert

  teethSum = 0;
  for ( i = 0; i < korkoTeeth; i++) {
    teethSum += teethStatus[i];
  }

}
