// ANLEGEN DER FUNKTION offset

/* Der Magnetsensor wird ausgelesen. Wenn sich der
   Sensor in Rechweite des Magneten befindet, wird die aktuelle Schrittzahl
   als Nullpunkt abgespeichert. Da der Sensor eine gewisse Reichweite hat,
   wird die Anzahl der Kontaktschritte mitgezählt und die Hälfte bei der
   Berechnung von stepZero in der nächsten Schleife berücksichtigt. So
   wird der Mittelpunkt des Magnetfeldes gefunden. Dieser ist dann Schritt Null.
*/

void offset() {

  pinMode(magnetPin, INPUT);

  int magnetStatus = digitalRead(magnetPin);

  //Wenn Magnetkontakt besteht, wird der Magnetzähler im 1 erhöht und der Schrittzähler auf null gesetzt.
  //int magnetRange = 0;
  if (magnetStatus == 1) {
    magnetRange++;
    // Zwischen dem Magnetn und der tatsächlichen Position des Krokodilmaul liegt ein Winkel von 135 Grad.
    stepCounter = 135 * degreeInSteps;
  }

  // Wenn noch kein Magnetkontakt besteht, ist der Magnetzähler null. Daher findet keine Beeinflussung des Schrittzählers statt.
  // Wenn kein Magnetkontakt mehr besteht, wird der Schrittzähler einmalig um die Hälfte der bisher gezählten Magnetkontakte erhöht.
  // Danach wird der Magnetzähler wieder auf null gesetzt, damit in den folgenden Schritten keine weitere Beeinflussung des
  // Schrittzähler mehr stattfindet.

  else {
    stepCounter = stepCounter + (magnetRange / 2);
    magnetRange = 0;
    stepCounter = (stepCounter + 1) % stepsPerRound;
  }
}
