// Anlegen der benötigten Variablen:

// Gebiss des Krokodils

// Um zu Hause zu testen, nur mit 5 Zähnen gearbeitet, um mehr Pins zur Verfügung zu haben
const int korkoTeeth = 5; // Anzahl der Zähne des Krokodils
int previousRoundTeethSum = 5; // In dieser Variable kann die Summe der gedrückten Zähne vor "nextPlayer" zwischengespeichert werden für einen Vergleich

int teethStatus[korkoTeeth];  // Array zum abspechern der Zustände aller Zähne
int previousRoundTeethStatus[korkoTeeth]; // In diesem Array kann der Satus aller Zähne vor "nextPlayer" zwischengespeichert werden für einen Vergleich
int teethSum = 0; // Die Anzahl der aktuell gedrückten Zähne soll in der Variablen teethSum abgespeichert werden
int mouthStatus = 0; // Der Status (auf/zu) des Krokodilmauls soll in der Variablen "mouthStatus" abgespeichert werden
int previousRoundMouthStatus = 0; // In dieser Variable kann der Maulstatus vor "nextPlayer" zwischengespeichert werden für einen Vergleich
int printCounter = 0; // Wird nur für den Entwicklungsmodus benötigt. Steuert die Unterschiedlichen seriallen Ausgaben je nach Spielfortschritt

// Zahnradpaarung / Getriebe / Motor

const int pinionTeeth = 17; // Anzahl der Zähne des treibenden Zahnrads
const int gearTeeth = 100; // Anzahl der Zähne des angetriebenen Zahnrads
const int motorSteps = 200; // Anzahl der Schritte, die der Motor für eine komplette Umdrehung der Welle benötigt
int stepperSpeed = 2000; // Motorgeschwindigleit hierüber einstellbar (1000 entspricht 2,35 Sekunden Pro Tellerumdrehung)
float gearRatio = 0; // Die Übersetzung wird in der setup Funktion berechnet
float degreeInSteps = 0; // Zur Speicherung der Position nach Umrechnung von Gerad in Schritte
float stepsInDegree = 0; // Zur Speicherung der Position nach Umrechnung von Schritten in Grad
int stepCounter = 0; // Zählt die Anzahl der Motorschritte
int stepZero = 0; // wird für die Berechnung in mehreren Funktionen benötigt
int stepsPerRound = 0;  // Die stepsPerRound werden in der setup Funktion berechnet. Anzahl der Schritte, die der Motor machen muss für eine Umdrehung des Drehtellers
int magnetRange = 0; // Reichweite des MAgneten in Motorschritten
int offsetCount = 0;  // Wird für die offset Funktion benötigt, welche in unterschiedlichen Funktionen aufgerufen wird


// Maximale Distanz zum Ultraschallsensor, in dem sich ein Glas befinden darf,
// so dass der Auslass bei ausgefahrenen Schienen noch das Glas erreichen kann.

int maximumRange = 20;

// Minimale Distanz zum Ultraschallsensor, so dass der Sensor das Glas noch erkennen
// kann. Näher adrf das Glas nicht an den Sensor gestellt werden, da das Glas vom Ausgießer nicht erreicht werden kann.

int minimumRange = 3;


// Den Digitalen Anschlüssen 2-12 werden Bezeichnungen des jeweilgen Zahns bzw. des Mauls zugewiesen

const int mouth = A3;
const int tooth1 = 3;
const int tooth2 = 4;
const int tooth3 = 5;
const int tooth4 = 6;
const int tooth5 = 7;
// const int tooth6 = 8;     // Um zu Hause zu testen, nur mit 5 Zähnen gearbeitet, um mehr Pins zur Verfügung zu haben
// const int tooth7 = 9;     // Um zu Hause zu testen, nur mit 5 Zähnen gearbeitet, um mehr Pins zur Verfügung zu haben
// const int tooth8 = 10;    // Um zu Hause zu testen, nur mit 5 Zähnen gearbeitet, um mehr Pins zur Verfügung zu haben
// const int tooth9 = 11;    // Um zu Hause zu testen, nur mit 5 Zähnen gearbeitet, um mehr Pins zur Verfügung zu haben
// const int tooth10 = 12;   // Um zu Hause zu testen, nur mit 5 Zähnen gearbeitet, um mehr Pins zur Verfügung zu haben


// Den Analogen Anschlüssen 1-2 wird der Motor für dir Rotation zugewiesen

const int directionPin1 = A0;      // Analoge als digitale Pins genutzt
const int stepPin1 = A1;           // Analoge als digitale Pins genutzt

// Den digitalen Anschlüssen 8-9 wird der Motor für dir Bewegung der Schiene zugewiesen
// Um zu Hause zu testen, nur mit 5 Zähnen gearbeitet, um mehr Pins zur Verfügung zu haben
// Die hier verwendeten PINS müssen wieder freigegben und anders belegt werden

const int directionPin2 = 8;
const int stepPin2 = 9;

// Dem Digitalen Anschluss A3 wird der Magnetsensor zugewiesen

const int magnetPin = A2;         // Analoge als digitale Pins genutzt


// Festlegen der digitalen PINs für den Ultraschallsensor als In- und Output

#define echoPin 13 // Echo Input-Pin
#define triggerPin 2 // Trigger Output-Pin

// Festlegen des digitalen Pins für den Glastaster

const int glasTrigger = A4;
const int railTrigger = A5;

// Festlegen der Digitalen Pins 10 - 11 für die Pumpe und das Magnetventil

const int pump = 10;
const int valve = 11;

// Dynamisches Array und Dimensionsvariablen für die Spielerpositionen

int** ppA;
const int rows = 4;
int columns;
// ACHTUNG: previousPlayer kann hier nicht beeinflusst werden, weil es durch die getPlayersPosition Funktion überschrieben wird!
int previousPlayer = 0;


void setup() {
  Serial.begin(9600);


  // Berechnung der Übersetzung

  gearRatio = (gearTeeth * 1.0 / pinionTeeth * 1.0); // *1.00, um die Nachkommastellen zu berücksichtigen

  // Umrechnung Grad in Motorschritte

  degreeInSteps = (motorSteps * 1.0 / 360 * 1.0) * gearRatio * 1.0;

  // Umrechnung Motorschritte in Grad

  stepsInDegree = 360 * 1.0 / (motorSteps * 1.0 * gearRatio * 1.0);

  // Berechnung der Motorschritte für eine 360° Drehung des Tellers

  stepsPerRound = motorSteps * gearRatio;


  // Countdown
  for (int i = 10; i > 0; i--) {
    Serial.println(i);
    delay(300);
  }

  // Initialisierung des Spiels, um Winkelposition zu erfassen

  initialization();

  // Ermittlung der Anzahl der Mitspielenden, sowie deren Postition und zugehörige Winkelbereiche

  ppA = getPlayersPositions();
  printppA(ppA);
}

void loop() {

  // Status der Gebisszustände (Zähne und Maul) abfragen

  jawStatus();
  doubleCheck();
  printStatus(); // Nur für den Entwicklungsmodus
  Serial.println("Warten, dass das Maul geöffnet wird.");                       // Nur für den Entwicklungsmodus
  Serial.println("-----------------------------------");                        // Nur für den Entwicklungsmodus
  // Solange das Maul geschlossen ist, frage weiter den Status ab
  // Sobald das Maul geöffnet ist, wird die Schleife verlassen.

  while (mouthStatus == 1) {
    jawStatus();
    doubleCheck();
  }

  // Der aktuelle Status, bevor sich das Krokodil zum/zur ersten/nächsten
  // Spielenden dreht, wird gespeichert

  saveStatus();
  Serial.println("Das Maul wurde geöffnet.");                                      // Nur für den Entwicklungsmodus

  // Nachdem die while Schleife verlassen wurde, ist das Krokodilmaul geöffnet (Abbruchbedingung)
  // Das Krokodil dreht sich nun zur/zum nächsten (oder ersten) Mitspielenden
  // Bleiben in der Schleife, so lange das Krokodil noch nicht zugebissen hat

  while (mouthStatus == previousRoundMouthStatus) {
    nextPlayer();
    printStatus();                                                                 // Nur für den Entwicklungsmodus

    // Status der Gebisszustände (Zähne und Maul) abfragen
    jawStatus();
    doubleCheck();

    // Solange keine Veränderung stattfindet, frage weiter den Status ab
    // Sobald eine Veränderung eines der Zustände auftritt, wird die Schleife verlassen.

    while (mouthStatus == previousRoundMouthStatus && teethSum == previousRoundTeethSum) {
      jawStatus();
      doubleCheck();
    }

    // Wenn die Veränderung mouthStatus NICHT betrifft, muss die Veränderung bei
    // teethSum stattgefunden haben.
    // Folglich wurde ein Zahn gedrückt, ohne dass das Krokodil zugebissen hat.
    // Der aktuelle Status wird gespeichert. Da immernoch git:
    // mouthStatus == previousRoundMouthStatus, wir die Schleife wiederholt
    // und nextPlayer ausgeführt

    if (mouthStatus == previousRoundMouthStatus) {
      saveStatus();
    }

    // Wenn die Veränderung mouthStatus betrifft, hat das Krokodil zugebissen.
    // die Funktion serveDrink wird daher ausgeführt.
    // Anschließend befindet sich das System wieder in Ausgangssituation, und die
    // loop Funktion beginnt erneut mit der Abfrage des Status.
    // Der/die letzte Spielende öffnet das Maul de Krokodils, damit es weiter geht.

    if (mouthStatus != previousRoundMouthStatus) {
      findGlas(); // serveDrink wird innerhalb der Funktion findGlas aufgerufen
      //nextPlayer wird jetzt wieder über die loop oben aufgerufen
    }
  }
}
