//  ANLEGEN DER FUNKTION serveDrink

void serveDrinkNew() {

  pinMode(directionPin2, OUTPUT);
  pinMode(stepPin2, OUTPUT);
  pinMode(pump, OUTPUT);
  pinMode(glasTrigger, INPUT_PULLUP);
  pinMode(railTrigger, INPUT_PULLUP);
  pinMode(triggerPin, OUTPUT);
  pinMode(echoPin, INPUT);


  digitalWrite(pump, LOW); // Die Pumpe soll zu Beginn ausgeschaltet sein
  digitalWrite(valve, LOW); // Das Magnetventil soll zu Beginn geschlossen sein

  int fast = 1000; // schnelle Motorgeschwingigkeit
  int slow = 2000; // langsame Motorgeschwingigkeit
  long distance; // Abstand zum Messobjekt
  long duration; // Dauer zwischen Schallaussendung und Echorücklauf
  int counter = 0; // Zählt die Anzahl der Versuche, ein Glas zu finden
  int stepsAfterStart = 0; // Zählt die zurückgelegten Motorschritte ab Start der Getränkeausgabe, um später dorthin zurück zu gehen
  float glasDistance = maximumRange + 1;// In der Variable glasDistance wird der Abstand des Glasen abgespeichert.
  int approachSpeed = 0; //
  int glasTriggerStatus = HIGH;
  int railTriggerStatus = LOW;


  // Schritt für Schritt wird der zu messende Bereich abgetastet. Nach jeder Messung wird der Motor einen Schritt weiter gestellt.

  glasTriggerStatus = digitalRead(glasTrigger);
  railTriggerStatus = digitalRead(railTrigger);

  if (glasTriggerStatus == HIGH && railTriggerStatus == LOW) {

    for (int counter = 0; counter < 3; counter++) {

      // Start der Abstandsmessung mit einer Signallänge von 10 Mikrosekunden
      digitalWrite(triggerPin, HIGH);
      delayMicroseconds(10);
      digitalWrite(triggerPin, LOW);

      // Warten auf das Echo und messen, wie lang das Signal ist
      duration = pulseIn(echoPin, HIGH);

      // Umrechnung der Zeit in Entfernug
      distance = duration / 58.2;

      // Prüfen, ob ein Gegenstand im vorgegeben Bereich / min. max. Abstand steht
      // Wenn kein Gals im erreichbaren Bereich steht, mache nichts und gehe zum nächsten Schritt:
      if (distance > maximumRange || distance < minimumRange) {
        if (counter < 2) {
          Serial.println("Es konnte kein Glas gefunden werden. Die Getränkeausgabe wird übersprungen.");
          Serial.println("-----------------------------------");  // nur für den Entwicklungsmodus
          delay(3000);
        }
        else {
          Serial.println("Es konnte kein Glas gefunden werden. Es wird erneut nach einem Glas gesucht.");
          Serial.println("-----------------------------------");  // nur für den Entwicklungsmodus
          delay(3000);
        }
      }

      // Wenn ein Gals im erreichbaren Bereich steht, speichere den aktuellen Abstand des Glases,
      // setze den Motorschrittzähler auf null und beginne dann an das Glas heranzufahren
      // Die Schleife soll dann nicht wiederholt werden. Daher wird counter hochgesetzt

      else {
        counter = 3;
        glasDistance  = distance;
        stepsAfterStart = 0;

        // Es sollen drei Versuche unternommen werden, näher an das Glas heranzufahren, falls der Schalter
        // bei Glaskontakt nicht zuverlässig funktioniert.

        // Vor Start des Motors auslesen, ob noch kein Glaskontakt besteht und ob die Zahnschiene noch nicht voll ausgefahren ist.

        for (int i = 0; i < 3; i++) {

          // So lange das Glas noch nicht berührt wurde und solange Die Schiene noch
          // nicht ganz ausgefahren wurde Soll der Motor einen Schritt weiter fahren.
          // dabei soll der Abstand zum Glas gemessen werden.

          glasTriggerStatus = digitalRead(glasTrigger);
          railTriggerStatus = digitalRead(railTrigger);

          while (glasTriggerStatus == HIGH && railTriggerStatus == LOW) {
            /*
                        // Start der Abstandsmessung mit einer Signallänge von 10 Mikrosekunden
                        digitalWrite(triggerPin, HIGH);
                        delayMicroseconds(10);
                        digitalWrite(triggerPin, LOW);

                        // Warten auf das Echo und messen, wie lang das Signal ist
                        duration = pulseIn(echoPin, HIGH);

                        // Umrechnung der Zeit in Entfernug
                        distance = duration / 58.2;

                        glasDistance  = distance;

                        // Wenn das der Glaskontakt kurz bevorsteht, soll der Motor Langsamer fahren, vorher schnell

                        if (glasDistance < 4) {
                          approachSpeed = slow;
                        }
                        else {
                          approachSpeed = fast;
                        }
            */
            // Dann startet der Motor und wird nach und nach immer einen Schritt weitergedreht
            // Motorrotation vorwärts
            // Pause nach jedem Schritt.

            approachSpeed = slow;

            digitalWrite(directionPin2, LOW);

            digitalWrite(stepPin2, HIGH);
            delayMicroseconds(approachSpeed);
            digitalWrite(stepPin2, LOW);
            delayMicroseconds(approachSpeed);

            // Die Motorschritte werden mitgezählt, damit später die gleiche Anzahl Schritte zurückgefahren werden kann.

            stepsAfterStart++;

            // Abfragen der Taster
            glasTriggerStatus = digitalRead(glasTrigger);
            railTriggerStatus = digitalRead(railTrigger);
          }

          // Wenn der Motor stoppt ist entweder der railTrigger ausgeschaltet (maximale Ausfahrlänge erreicht)
          // oder der glasTrigger eingeschaltet (Glakontakt)
          // Im ersten Fall wurde dasGlas nicht gefunden. Der Motor fährt zurück in die Ausgangsposition und versucht es erneut.
          // Im zweiten Fall Beginnt die Augabe des Getränks, denn der Ausgießer befindet sich über dem Glas.

          // Jetzt wird überprüft, ob der Schalte durch das Glas dauerhaft gedrückt wurde
          // und ob die Zahnschiene noch nicht ganz ausgefahren ist.

          //glasTriggerStatus = digitalRead(glasTrigger);
          //railTriggerStatus = digitalRead(railTrigger);

          // Wenn Glaskontakt besteht, wird die Pume für 3 Sekunden eingeschaltet und das Magnetventil währeddessen geöffnet.

          if (glasTriggerStatus == LOW) {

            // Wenn der Schalter konstant Glaskontakt signalisiert und das Getränk ausgegeben wurde,
            // soll die Schleife verlassen werden.

            i = 3;

            delay(1000);

            digitalWrite(pump, HIGH);
            delay(4000);
            digitalWrite(pump, LOW);

            Serial.println("Die Getränkeausgabe beginnt.");       // nur für den Entwicklungsmodus
            Serial.println("-----------------------------------");  // nur für den Entwicklungsmodus
            Serial.println("Die Getränkeausgabe ist abgeschlossen.");       // nur für den Entwicklungsmodus
            Serial.println("-----------------------------------");  // nur für den Entwicklungsmodus

            delay(1000);

          }
          else {

            if (railTriggerStatus == HIGH) {
              Serial.println("Das Ende der Zahnschiene wurde erreicht. Es konnte kein Glas gefunden werden.");
              Serial.println("-----------------------------------");

              // Auch dann soll die Schleife verlassen werden.

              i = 3;
            }
          }
          // Wenn keiner der Fälle zutrifft, wird die Schleife bis zum dritten Versuch wiederholt,
          // um näher an das Glas Heranzufahren
          // Wenn es nach drei Versuchen nicht funktioniert hat, soll abgebrochen werden

          if (i == 2) {
            Serial.println("Der Taster konnte kein Glas erkennen.");       // nur für den Entwicklungsmodus
            Serial.println("-----------------------------------");  // nur für den Entwicklungsmodus
            delay(3000);
          }
        }

        // Der Motor soll dann schnell zurückfahren in die Ausgangsposition

        Serial.println("Die Rückfahrt wird eingeleitet.");
        Serial.println("-----------------------------------");  // nur für den Entwicklungsmodus

        approachSpeed = fast;
        for (int i = 0; i < stepsAfterStart; i++) {
          digitalWrite(directionPin2, HIGH);

          digitalWrite(stepPin2, HIGH);
          delayMicroseconds(approachSpeed);
          digitalWrite(stepPin2, LOW);
          delayMicroseconds(approachSpeed);
        }
      }
    }
  }
  else {
    Serial.println("Es Liegt ein Fehler vor.");
    Serial.println("Die Zahnstange ist nicht eingefahren, oder es besteht direkter Glaskontakt.");
    Serial.println("-----------------------------------");  // nur für den Entwicklungsmodus
    delay(3000);
  }
}
